[4/9] Add replace-spdx-license.sh script

Message ID 87o8ono43a.fsf@redhat.com
State Superseded
Headers
Series Relicensing Libabigail to Apache 2.0 + LLVM Exception |

Commit Message

Dodji Seketeli July 10, 2020, 2:08 p.m. UTC
  This script is to replace an SPDX license ID by another one.
I.e, it's to perform an actual re-licensing of a given file.

A way to use the script is this:

    replace-spdx-license.sh  --from LGPL-3.0-or-later \
			      --to  "Apache-2.0 WITH LLVM-exception" \
			      some-file-to-relicense.cc

	* relicensing-scripts/replace-spdx-license.sh: New script.

Signed-off-by: Dodji Seketeli <dodji@redhat.com>
---
 relicensing-scripts/replace-spdx-license.sh | 75 +++++++++++++++++++++++++++++
 1 file changed, 75 insertions(+)
 create mode 100755 relicensing-scripts/replace-spdx-license.sh
  

Comments

Jonathan Wakely July 10, 2020, 5:29 p.m. UTC | #1
On 10/07/20 16:08 +0200, Dodji Seketeli wrote:
>This script is to replace an SPDX license ID by another one.
>I.e, it's to perform an actual re-licensing of a given file.
>
>A way to use the script is this:
>
>    replace-spdx-license.sh  --from LGPL-3.0-or-later \
>			      --to  "Apache-2.0 WITH LLVM-exception" \
>			      some-file-to-relicense.cc
>
>	* relicensing-scripts/replace-spdx-license.sh: New script.
>
>Signed-off-by: Dodji Seketeli <dodji@redhat.com>
>---
> relicensing-scripts/replace-spdx-license.sh | 75 +++++++++++++++++++++++++++++
> 1 file changed, 75 insertions(+)
> create mode 100755 relicensing-scripts/replace-spdx-license.sh
>
>diff --git a/relicensing-scripts/replace-spdx-license.sh b/relicensing-scripts/replace-spdx-license.sh
>new file mode 100755
>index 0000000..5fdbc91
>--- /dev/null
>+++ b/relicensing-scripts/replace-spdx-license.sh
>@@ -0,0 +1,75 @@
>+#!/bin/sh
>+# SPDX-License-Identifier: Apache-2.0 WITH LLVM-exception
>+# Author: Dodji Seketeli <dodji@redhat.com>
>+
>+from_license_id=
>+to_license_id=
>+input_file=
>+prog=$0
>+
>+display_usage()
>+{
>+    echo "$prog: [options] --from <from-spdx-license-id> --to <to-spdx-license-id> <file>"
>+    echo "  where options can be:"
>+    echo "   -h|--h		display this help"
>+}
>+
>+main()
>+{
>+    header=$(head --lines=5 $input_file | grep "SPDX-License-Identifier:")
>+    if test "x$header" != x; then
>+	license=$(echo "$header" | sed -r "s/^.*(SPDX-License-Identifier:)[ 	]*([^*/]+).*$/\2/")
>+    fi
>+
>+    if test "x$license" != x -a "$license" = "$from_license_id"; then
>+	sed -i -r "s/$from_license_id/$to_license_id/" $input_file
>+	exit 0
>+    fi
>+
>+    exit 1
>+}
>+
>+# This program takes at least 5 arguments
>+if test $# -lt 5; then
>+    display_usage
>+    exit 1
>+fi
>+
>+# Parse parameters
>+while test $# -gt 1; do
>+    case "$1" in
>+	-h|--h)
>+	    display_usage
>+	    exit 1

Same comment again. I'd exit 0 for --help, and redirect the
display_usage output to stderr for the other cases where it really is
incorrect usage.

>+	    ;;
>+
>+	-f|--from)
>+	    from_license_id=$2
>+	    shift
>+	    ;;
>+
>+	-t|--to)
>+	    to_license_id=$2
>+	    shift
>+	    ;;
>+
>+	-*)
>+	    display_usage
>+	    exit 1
>+	    ;;
>+
>+	*)
>+	    input_file="$1"
>+	    ;;
>+    esac
>+    shift
>+done
>+
>+if test $# -lt 1; then
>+    display_usage
>+    exit 1
>+fi
>+
>+input_file=$1
>+
>+main
>-- 
>1.8.3.1
>
>
>-- 
>		Dodji
>
  
Dodji Seketeli July 13, 2020, 11:21 a.m. UTC | #2
Jonathan Wakely <jwakely@redhat.com> writes:

[...]


>>+# Parse parameters
>>+while test $# -gt 1; do
>>+    case "$1" in
>>+	-h|--h)
>>+	    display_usage
>>+	    exit 1
>
> Same comment again. I'd exit 0 for --help, and redirect the
> display_usage output to stderr for the other cases where it really is
> incorrect usage.

Fixed.

Here is the updated patch that is going to be part of a v2 series that
I'll send out shortly.

Cheers,

From 67c937cc936a46e0952fd683ff57f50ed605d0ba Mon Sep 17 00:00:00 2001
From: Dodji Seketeli <dodji@redhat.com>
Date: Fri, 29 May 2020 10:45:34 +0200
Subject: [PATCH 4/9] Add replace-spdx-license.sh script

This script is to replace an SPDX license ID by another one.
I.e, it's to perform an actual re-licensing of a given file.

A way to use the script is this:

    replace-spdx-license.sh  --from LGPL-3.0-or-later \
			      --to  "Apache-2.0 WITH LLVM-exception" \
			      some-file-to-relicense.cc

	* relicensing-scripts/replace-spdx-license.sh: New script.

Signed-off-by: Dodji Seketeli <dodji@redhat.com>
Signed-off-by: Matthias Maennich <maennich@google.com>
---
 relicensing-scripts/replace-spdx-license.sh | 75 +++++++++++++++++++++++++++++
 1 file changed, 75 insertions(+)
 create mode 100755 relicensing-scripts/replace-spdx-license.sh

diff --git a/relicensing-scripts/replace-spdx-license.sh b/relicensing-scripts/replace-spdx-license.sh
new file mode 100755
index 0000000..f634528
--- /dev/null
+++ b/relicensing-scripts/replace-spdx-license.sh
@@ -0,0 +1,75 @@
+#!/bin/sh
+# SPDX-License-Identifier: Apache-2.0 WITH LLVM-exception
+# Author: Dodji Seketeli <dodji@redhat.com>
+
+from_license_id=
+to_license_id=
+input_file=
+prog=$0
+
+display_usage()
+{
+    echo "$prog: [options] --from <from-spdx-license-id> --to <to-spdx-license-id> <file>"
+    echo "  where options can be:"
+    echo "   -h|--h		display this help"
+}
+
+main()
+{
+    header=$(head --lines=5 $input_file | grep "SPDX-License-Identifier:")
+    if test "x$header" != x; then
+	license=$(echo "$header" | sed -r "s/^.*(SPDX-License-Identifier:)[ 	]*([^*/]+).*$/\2/")
+    fi
+
+    if test "x$license" != x -a "$license" = "$from_license_id"; then
+	sed -i -r "s/$from_license_id/$to_license_id/" $input_file
+	exit 0
+    fi
+
+    exit 1
+}
+
+# This program takes at least 5 arguments
+if test $# -lt 5; then
+    >&2 display_usage
+    exit 1
+fi
+
+# Parse parameters
+while test $# -gt 1; do
+    case "$1" in
+	-h|--h)
+	    display_usage
+	    exit 0
+	    ;;
+
+	-f|--from)
+	    from_license_id=$2
+	    shift
+	    ;;
+
+	-t|--to)
+	    to_license_id=$2
+	    shift
+	    ;;
+
+	-*)
+	    >&2 display_usage
+	    exit 1
+	    ;;
+
+	*)
+	    input_file="$1"
+	    ;;
+    esac
+    shift
+done
+
+if test $# -lt 1; then
+    >&2 display_usage
+    exit 1
+fi
+
+input_file=$1
+
+main
  

Patch

diff --git a/relicensing-scripts/replace-spdx-license.sh b/relicensing-scripts/replace-spdx-license.sh
new file mode 100755
index 0000000..5fdbc91
--- /dev/null
+++ b/relicensing-scripts/replace-spdx-license.sh
@@ -0,0 +1,75 @@ 
+#!/bin/sh
+# SPDX-License-Identifier: Apache-2.0 WITH LLVM-exception
+# Author: Dodji Seketeli <dodji@redhat.com>
+
+from_license_id=
+to_license_id=
+input_file=
+prog=$0
+
+display_usage()
+{
+    echo "$prog: [options] --from <from-spdx-license-id> --to <to-spdx-license-id> <file>"
+    echo "  where options can be:"
+    echo "   -h|--h		display this help"
+}
+
+main()
+{
+    header=$(head --lines=5 $input_file | grep "SPDX-License-Identifier:")
+    if test "x$header" != x; then
+	license=$(echo "$header" | sed -r "s/^.*(SPDX-License-Identifier:)[ 	]*([^*/]+).*$/\2/")
+    fi
+
+    if test "x$license" != x -a "$license" = "$from_license_id"; then
+	sed -i -r "s/$from_license_id/$to_license_id/" $input_file
+	exit 0
+    fi
+
+    exit 1
+}
+
+# This program takes at least 5 arguments
+if test $# -lt 5; then
+    display_usage
+    exit 1
+fi
+
+# Parse parameters
+while test $# -gt 1; do
+    case "$1" in
+	-h|--h)
+	    display_usage
+	    exit 1
+	    ;;
+
+	-f|--from)
+	    from_license_id=$2
+	    shift
+	    ;;
+
+	-t|--to)
+	    to_license_id=$2
+	    shift
+	    ;;
+
+	-*)
+	    display_usage
+	    exit 1
+	    ;;
+
+	*)
+	    input_file="$1"
+	    ;;
+    esac
+    shift
+done
+
+if test $# -lt 1; then
+    display_usage
+    exit 1
+fi
+
+input_file=$1
+
+main